#include <iostream>
#include <stdio.h>
#include <math.h>
#include "polylib.h"

/*
 To compile (in same directory as polylib.c and polylib.h):
g++ -c polylib.c
g++ -c exercise1c.cpp 
g++ -o exercise1c exercise1c.o polylib.o
*/

using namespace std;
using namespace polylib;

double *dvector(int np);
void *func(int np, double *z, double *p);
double integr(int np, double *w, double *p);
void *chi(int np, double *x, double *z, double *Jac, double *bound);


main()
{

  int np=3;
  double *x,*z,*w,*p,*Jac,*bound,sum=0;

  /* set up vectors */
  x = dvector(np);
  z = dvector(np);
  w = dvector(np);
  p = dvector(np);
  Jac = dvector(1);
  bound = dvector(2);

  /* define domain [bound[0],bound[1]] */
  bound[0] = 0;
  bound[1] = M_PI/2;

  /* get zeros and weights */
  zwgll(z, w, np);

  /* get mapping details; x-locations and Jacobian */
  chi(np, x, z, Jac, bound);

  /* calculate p=sin(x) at np points x */
  func(np, x, p);

  /* integrate p over [bound[0],bound[1]] */
  sum = Jac[0]*integr(np, w, p);

  /* generate output */
  cout <<"\nQ = " << np << "\n\n";
  for(int i = 0;i<np;i++ ){
    cout <<"x = " << x[i] << "\t\tp = " << p[i]<<  "\n";
  }
  cout << "\nIntegral = " << sum  << "\n";
  cout << "error = " << sum - 1 <<  "\n\n";
}

double *dvector(int n)
{
  double *v;

  v = (double *)malloc(n*sizeof(double));
  return v;
}

void *func(int np, double *x, double *p)
{  
  for(int i = 0;i<np;i++){
    p[i] = sin(x[i]);
  }
   
}

double integr(int np, double *w, double *p)
{
  register double sum = 0.;

  for(int i=0;i<np;i++){
    sum = sum + p[i]*w[i]; 
  }
  return sum;
}

void *chi(int np, double *x, double *z, double *Jac,double *bound)
{
  for(int i=0;i<np;i++){
    x[i] = ((1 - z[i])/2)*bound[0] + ((1 + z[i])/2)*bound[1];
  }
  Jac[0] = (-bound[0]/2) + (bound[1]/2);
}
